#ifndef DEF_MAPS

#define DEF_MAPS

#include "../MapsCallbacks.h"
#include "Maps_Tilesets.h"

/** General Functions **/

/*
* Get collision map corresponding to specified map ID and return the collision data at specified index
*/
unsigned char Maps_GetCollisionDataAt(unsigned int _Index);

/*
* Check if specified array contains this tile
*/
static unsigned char Maps_IsCollidingTile(unsigned char _Tile, unsigned char* _CollidingTileArray, unsigned char _NbCollidingTile);

/** Map 01 **/

#define MAP01_WIDTH 20
#define MAP01_HEIGHT 18
#define MAP01_NBTILE 360
#define MAP01_BANK 0
#define MAP01_ID 0
#define MAP01_LOAD_PARAMS MAP01_ID, Map01_Data, MapsTileset0, TILESET0_NBTILE, MAP01_WIDTH, MAP01_HEIGHT, MapsCallbacks_OnMap01Loaded
#define MAP01_ISCOLLIDINGTILE(_Tile) _Tile < 102 && _Tile != 84 && _Tile != 85 && (_Tile < 48 || _Tile > 79) && _Tile != 23 && _Tile != 24

// Map data
extern const char Map01_Data[];

/** Map 02 **/

#define MAP02_WIDTH 20
#define MAP02_HEIGHT 18
#define MAP02_NBTILE 360
#define MAP02_BANK 0
#define MAP02_ID 1
#define MAP02_LOAD_PARAMS MAP02_ID, Map02_Data, MapsTileset0, TILESET0_NBTILE, MAP02_WIDTH, MAP02_HEIGHT, MapsCallbacks_OnMap02Loaded
#define MAP02_ISCOLLIDINGTILE(_Tile) _Tile == 0

// Map data
extern const char Map02_Data[];

/** Map 03 **/

#define MAP03_WIDTH 20
#define MAP03_HEIGHT 18
#define MAP03_NBTILE 360
#define MAP03_BANK 0
#define MAP03_ID 2
#define MAP03_LOAD_PARAMS MAP03_ID, Map03_Data, MapsTileset0, TILESET0_NBTILE, MAP03_WIDTH, MAP03_HEIGHT, MapsCallbacks_OnMap03Loaded
#define MAP03_ISCOLLIDINGTILE(_Tile) _Tile == 0

// Map data
extern const char Map03_Data[];

/** Map Game Over **/

#define MAP_GAMEOVER_WIDTH 20
#define MAP_GAMEOVER_HEIGHT 18
#define MAP_GAMEOVER_NBTILE 360
#define MAP_GAMEOVER_BANK 0
#define MAP_GAMEOVER_ID 3
#define MAP_GAMEOVER_LOAD_PARAMS MAP_GAMEOVER_ID, MapGameOver_Data, MapsTileset0, TILESET0_NBTILE, MAP_GAMEOVER_WIDTH, MAP_GAMEOVER_HEIGHT, MapsCallbacks_OnMapGameOverLoaded

// Map data
extern const char MapGameOver_Data[];

#endif