#include "Character.h"
#include "../TurnManager/TurnManager.h"
#include "../../Engine/Inputs/InputManager.h"
#include "../../Engine/Movables/Movable.h"
#include "../../Engine/Math/Vector.h"

Lever* m_ActivableLever = NULL;

void Character_CheckInput()
{
    Vector translation = {0, 0};

    if(InputManager_IsButtonPressed(J_A))
    {
        TurnManager_GoToNextTurn();
        // Character_ActivateLever();
    }

    else if(InputManager_IsButtonDown(J_UP))
        translation.y--;

    else if(InputManager_IsButtonDown(J_DOWN))
        translation.y++;

    else if(InputManager_IsButtonDown(J_LEFT))
        translation.x--;

    else if(InputManager_IsButtonDown(J_RIGHT))
        translation.x++;
    
    Character_Move(&translation);
}

void Character_Move(Vector* _Translation)
{
    if(Character_CanMove() == TRUE)
    {
        Movable* playerMovable = Movable_FindMovable(TAG_PLAYER);

        if (Movable_CanTryMoving(playerMovable))
        {
            if (_Translation->x > 0)
                Movable_SetSpriteAnim(playerMovable, &SpriteAnim_PlayerMoveRight_Left, &SpriteAnim_PlayerMoveRight_Right);
            else if (_Translation->x < 0) 
                Movable_SetSpriteAnim(playerMovable, &SpriteAnim_PlayerMoveLeft_Left, &SpriteAnim_PlayerMoveLeft_Right);
            else if (_Translation->y > 0)
                Movable_SetSpriteAnim(playerMovable, &SpriteAnim_PlayerMoveDown_Left, &SpriteAnim_PlayerMoveDown_Right);
            else if (_Translation->y < 0)
                Movable_SetSpriteAnim(playerMovable, &SpriteAnim_PlayerMoveUp_Left, &SpriteAnim_PlayerMoveDown_Right);

            //Movable_SetSpriteAnim(playerMovable, &SpriteAnim_PlayerMoveLeft_Left, &SpriteAnim_PlayerMoveLeft_Right);
        }

        Movable_Translate(playerMovable, _Translation, TRUE);
    }
}

UINT8 Character_CanMove()
{
    return TRUE;
}

/**
 * Make character activate lever.
 */
void Character_ActivateLever()
{
    if(Character_CanActivateLever())
    {
        if(m_ActivableLever != NULL)
        {
            
        }
    }
    
}

/**
 * Checks if player can activate an object.
 */
UINT8 Character_CanActivateLever()
{
    return TRUE;
}